autowatch = 1;
post("Ampro: Processing loaded!");
post();

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

var player, nchnls, source, testerToggle, timeSigNum, rec, sendMonitor, ssFBM, p;

var input	= new Array(32);
var output	= new Array(32);
var multi 	= new Array(32);
var gates	= new Array(32);
var x_offset = 150;
var y_offset = 50;
var x_position = 100;
var y_position = 500;

p = this.patcher;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function _create(n){
	
	nchnls = n;
	
	var i;

	player = p.newdefault(x_position+81, y_position-81, "sfplay~", nchnls+1, 0, 1);
	
	source = p.getnamed("dummy_source");
	testerToggle = p.getnamed("_Ampro0dBTesterToggle");
	timeSigNum = p.getnamed("_AmproTimeSigNum");
	rec = p.getnamed("_AmproRec");
	sendMonitor = p.getnamed("_AmproSendMonitor");
	ssFBM = p.getnamed("_AmproStartStopFBMessage");

	p.connect(source, 1, player, 0);
	p.connect(player, nchnls+1, timeSigNum, 0);
	p.connect(player, nchnls+2, rec, 1);
	p.connect(player, nchnls+2, ssFBM, 0);
	p.connect(player, nchnls, sendMonitor, 0);

	for(i=0;i<nchnls;i++){
		input[i] = p.newdefault(x_position+i*x_offset, y_position, "receive~", i+1+"_Ampro_In");//"adc~", i+1);
		multi[i] = p.newdefault(x_position+i*x_offset, y_position+y_offset, "*~");
		output[i] = p.newdefault(x_position+i*x_offset, y_position+y_offset*2, "dac~", i+1)
		gates[i] = p.newdefault(x_position-50+i*x_offset, y_position+y_offset*.5, "gate~");
		p.connect(input[i], 0, multi[i], 0);
		p.connect(player, i, multi[i], 1);
		p.connect(multi[i], 0, output[i], 0);
		p.connect(input[i], 0, gates[i], 1);
		p.connect(gates[i], 0, output[i], 0);
		p.connect(testerToggle, 0, gates[i], 0);
	}

	
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

function _cleanup(){

	p.remove(player);
	for(i=0;i<nchnls;i++){
		p.remove(input[i]);
		p.remove(multi[i]);
		p.remove(output[i]);
		p.remove(gates[i]);
	}

}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////